<?php

if (!class_exists('AuthorityRobotAdminManger')) {
    class AuthorityRobotAdminManger {
        /**
         * Class constructor
         */
        public function __construct() {

            add_action('add_meta_boxes', array($this, 'ara_add_meta_boxes'));
            add_action('admin_init', array($this, 'ara_admin_init'));
            add_action('admin_menu', array($this, 'ara_admin_menu'));
            // ajax module
            //add_action( 'wp_ajax_ara_search_keyword', array( $this, 'ara_ajax_search_keyword'));
            //add_action( 'wp_ajax_ara_get_article', array( $this, 'ara_ajax_get_article'));
            add_action( 'wp_ajax_ara_search_keyword', array( $this, 'ara_ajax_search_keyword_new'));
            add_action( 'wp_ajax_ara_get_article', array( $this, 'ara_ajax_get_article_new'));
            add_action( 'wp_ajax_ara_get_video', array( $this, 'ara_ajax_get_video'));
            add_action( 'wp_ajax_ara_get_image', array( $this, 'ara_ajax_get_image'));
            add_action( 'wp_ajax_ara_get_shortcode_article', array( $this, 'ara_ajax_get_shortcode_article') );
        }

        // ----------   MetaBox Section ------------------ //
        function ara_add_meta_boxes() {

            add_meta_box('authority_robot_project_normal_meta' ,
                __('Authority Robot MetaBox', 'ar_lang') ,
                array($this, 'ara_metabox_normal'),
                'post',
                'normal',
                'high');

            add_meta_box('authority_robot_project_normal_meta' ,
                __('Authority Robot MetaBox', 'ar_lang') ,
                array($this, 'ara_metabox_normal'),
                'page',
                'normal',
                'high');
        }

        function ara_metabox_normal($post) {
        ?>
            <div id="ara-metabox-container">
                <div id="ara-metabox-search-field" class="ara-element">
                    <label><?php echo _e('Keyword', 'ar_lang');?></label>
                    <input type="text" id="ara-search-keyword" name="ara-search-keyword" />
                    <button class="button button-primary button-large" id="ara-search-button"><?php echo _e('Search', 'ar_lang');?></button>
                </div>
                <div id="ara-metabox-checkbox">
                    <label>
                        <input type="checkbox" id="ara-checkbox-article" name="ara-checkbox-article" value="1" checked/> Show Article search
                    </label>
                    <label>
                        <input type="checkbox" id="ara-checkbox-video" name="ara-checkbox-video" value="1" checked/> Show Youtube search
                    </label>
                    <label>
                        <input type="checkbox" id="ara-checkbox-image" name="ara-checkbox-image" value="1" checked/> Show Flickr Image search
                    </label>
                </div>
                <div id="ara-metabox-article-field" class="ara-element">
                    <p class="ara-element-title"><b><?php echo _e('Article from ezinemark.com', 'ar_lang'); ?></b></p>

                    <div class="ara-metabox-button">
                        <button class="button button-secondary" id="ara-article-button"><?php echo _e('Get another', 'ar_lang');?></button>
                        <input type="hidden" id="article_page_num" value="1" name="article_page_num" />
                    </div>
                    <div class="ara-metabox-content">
                        <?php
                        /*wp_editor( "", 'custom-content', array(
                            'dfw' => true,
                            'tabfocus_elements' => 'insert-media-button,save-post',
                            'editor_height' => 360,
                        ) );*/
                        ?>
                    </div>
                    <div class="ara-metabox-shortcode">
                        <button class="button button-secondary"  id="ara-article-get-shortcode"><?php echo _e('Get ShortCode', 'ar_lang'); ?></button>
                        <textarea class="ara-metabox-shortcode-text" id="ara-metabox-shortcode-article"></textarea>
                    </div>
                </div>
                <div id="ara-metabox-youtube-field" class="ara-element">
                    <p class="ara-element-title"><b><?php echo _e('Youtube Video', 'ar_lang'); ?></b></p>
                    <div class="ara-metabox-button">
                        <button class="button button-secondary" id="ara-video-button"><?php echo _e('Get another', 'ar_lang');?></button>
                        <input type="hidden" id="video_page_num" value="1" name="video_page_num" />
                        <input type="hidden" id="ara-youtube-id" name="ara-youtube-id" value="" />
                    </div>
                    <div class="ara-metabox-content1">
                    </div>
                    <div class="ara-metabox-shortcode">
                        <button class="button button-secondary"  id="ara-video-get-shortcode"><?php echo _e('Get ShortCode', 'ar_lang'); ?></button>
                        <label>Width  </label> <input type="text" id="ara-youtube-width" name="ara-youtube-width" value="400" pattern="[0-9]+" />
                        <label>Height </label> <input type="text" id="ara-youtube-height" name="ara-youtube-height" value="310" pattern="[0-9]+" />
                        <textarea class="ara-metabox-shortcode-text" id="ara-metabox-shortcode-youtube"></textarea>
                    </div>
                </div>
                <div id="ara-metabox-flickr-field" class="ara-element">
                    <p class="ara-element-title"><b><?php echo _e('Flickr Images', 'ar_lang'); ?></b></p>
                    <div class="ara-metabox-button">
                        <button class="button button-secondary" id="ara-flickr-button"><?php echo _e('Get another', 'ar_lang');?></button>
                        <input type="hidden" id="flickr_page_num" value="1" name="flickr_page_num" />
                    </div>
                    <div class="ara-metabox-content1"></div>
                    <div class="ara-metabox-shortcode">
                        <button class="button button-secondary"  id="ara-image-get-shortcode"><?php echo _e('Get ShortCode', 'ar_lang'); ?></button>
                        <label>Width  </label> <input type="text" id="ara-image-width" name="ara-youtube-width" value="400" pattern="[0-9]+" />
                        <label>Height </label> <input type="text" id="ara-image-height" name="ara-youtube-height" value="310" pattern="[0-9]+" />
                        <textarea class="ara-metabox-shortcode-text" id="ara-metabox-shortcode-image"></textarea>
                    </div>
                </div>
            </div>
        <?php
        }

        // ----------- Add JS Script & CSS in admin post and page edit page
        function ara_admin_init() {
            wp_register_script('ara_main_jquery', AUTHORITY_ROBOT_URL . 'js/main.js', array('jquery'), '1.0.0' );
            wp_register_script('ara_base_jquery', AUTHORITY_ROBOT_URL . 'js/jquery.base64.min.js', array('jquery'), '1.1.1' );
            wp_register_script('ara_loadmask', AUTHORITY_ROBOT_URL . 'js/jquery.loadmask.js', array('jquery'), '1.3.1' );

            wp_register_style( 'ara_admin_css', AUTHORITY_ROBOT_URL . 'css/admin.css', array(), '1.0.0', 'all' );
            wp_register_style( 'ara_loadmask_css', AUTHORITY_ROBOT_URL . 'js/jquery.loadmask.css', array(), '1.0.0', 'all' );

        }
        function ara_admin_menu() {
            add_action( 'admin_print_scripts-post-new.php' , array($this, 'ara_add_admin_script'));
            add_action( 'admin_print_scripts-post.php' , array($this, 'ara_add_admin_script'));
            add_action( 'admin_print_styles-post-new.php', array($this, 'ara_add_admin_style'));
            add_action( 'admin_print_styles-post.php', array($this, 'ara_add_admin_style'));
        }

        function ara_add_admin_script() {
            wp_enqueue_script('ara_base_jquery');
            wp_enqueue_script('ara_loadmask');
            wp_enqueue_script('ara_main_jquery');

            wp_localize_script('ara_main_jquery', 'ajax_object',
                array( 'ajax_url' => admin_url( 'admin-ajax.php' ), 'we_value' => 1234 ) );
        }

        function ara_add_admin_style() {
            wp_enqueue_style('ara_admin_css');
            wp_enqueue_style('ara_loadmask_css');
        }


        // ------------- AJAX Module ----------------------- //

        /**
         * Ajax module for keyword search
         */
        function ara_ajax_search_keyword() {
            $keyword = $_POST['keyword'];
            $page_num = 1;
            while(true) {
                $article_content = get_article_contents($keyword, $page_num);
                if($article_content == null)
                    break;
                if($article_content['article_content'] == "") {
                    $page_num ++;
                    continue;
                }
                else
                    break;
            }

            $article_content['article_page_num'] = $page_num;
            $youtube_content = get_youtube_contents($keyword, 1);
            $filckr_content = get_flickr_contents($keyword, 1);

            $response = array(
                'article_result' => $article_content,
                'video_result' => $youtube_content,
                'image_result' => $filckr_content
            );
            echo json_encode($response);
            die();
        }

        function ara_ajax_search_keyword_new() {
            $keyword = $_POST['keyword'];
            $page_num = 1;

            $article_content = get_article_ezinemark($keyword, $page_num);
            $article_content['article_page_num'] = $page_num;
            if(isset($article_content['error'])) {
                $article_content = null;
            }
            $youtube_content = get_youtube_contents($keyword, 1);
            $filckr_content = get_flickr_contents($keyword, 1);

            $response = array(
                'article_result' => $article_content,
                'video_result' => $youtube_content,
                'image_result' => $filckr_content
            );
            echo json_encode($response);
            die();
        }
        /**
         * Ajax module for get another article
         */
        function ara_ajax_get_article() {
            $keyword = $_POST['keyword'];
            $page_number = $_POST['page_num'];
            while(true) {
                $article_content = get_article_contents($keyword, $page_number);
                if($article_content == null)
                    break;
                if($article_content['article_content'] == "") {
                    $page_number ++;
                    continue;
                }
                else
                    break;
            }
            $article_content['article_page_num'] = $page_number;
            echo json_encode($article_content);
            die();
        }

        function ara_ajax_get_article_new() {
            $keyword = $_POST['keyword'];
            $page_number = $_POST['page_num'];

            $article_content = get_article_ezinemark($keyword, $page_number);
            $article_content['article_page_num'] = $page_number;
            if(isset($article_content['error'])) {
                $article_content = null;
            }

            echo json_encode($article_content);
            die();
        }
        /**
         * Ajax module for get another youtube video
         */
        function ara_ajax_get_video() {
            $keyword = $_POST['keyword'];
            $page_number = $_POST['page_num'];
            $youtube_content = get_youtube_contents($keyword, $page_number);
            echo json_encode($youtube_content);
            die();
        }

        /**
         * Ajax module for get another flickr image
         */
        function ara_ajax_get_image() {
            $keyword = $_POST['keyword'];
            $page_number = $_POST['page_num'];
            $filckr_contents = get_flickr_contents($keyword, $page_number);
            echo json_encode($filckr_contents);
            die();
        }

        /**
         * Ajax module for get article shortcode
         */
        function ara_ajax_get_shortcode_article() {
            global $wpdb;
            $encode_html = $_POST['encode_html'];
            $query = 'INSERT INTO ' .  AUTHORITY_ROBOT_TABLE . ' ';
            $query .= '(content) ';
            $query .= "VALUES ('{$encode_html}')";

            $wpdb->query( $query );
            $query = 'SELECT COUNT(*) FROM '. AUTHORITY_ROBOT_TABLE . ';';
            $count = $wpdb->get_var($query);
            echo $count;
            die();

        }


    }

    new AuthorityRobotAdminManger();
}