<?php
/*
Plugin Name: WP Authority Bot
Plugin URI: www.wpauthoritybot.com
Description: This plugin provides features that helpful for inserting article of ezinemark.com, a Youtube video and a Flickr image.
Version: 1.0.0
Author: AP Sayers
Author URI: www.wpauthoritybot.com

* LICENSE
    Copyright 2013 AP Sayers  (email : info@wpauthoritybot.com)
*/

/**
 * CONST DEFINE
 */
define( 'AUTHORITY_ROBOT_PATH', plugin_dir_path(__FILE__) );
define( 'AUTHORITY_ROBOT_URL', plugin_dir_url(__FILE__) );
define( 'ARTICLE_URL', 'http://ezinearticles.com');
define( 'VIDEO_URL', 'http://www.youtube.com/');
define( 'IMAGE_URL', 'http://www.flickr.com/');
define( 'AUTHORITY_ROBOT_TABLE', 'authority_robot_table');


/**
 * Plugin Init Process
 * */

add_action( 'authority_robot_init', 'authority_robot_init_process' );

function authority_robot_init_process() {

    authority_robot_load_files();
}

function authority_robot_load_files()
{
    require_once( AUTHORITY_ROBOT_PATH.'/lib/simple_html_dom.php');
    require_once( AUTHORITY_ROBOT_PATH.'/lib/function.php' );
    require_once( AUTHORITY_ROBOT_PATH . '/admin/admin.php' );
    require_once( AUTHORITY_ROBOT_PATH . '/uninstall.php' );
    register_deactivation_hook( __FILE__, 'authority_robot_deactive_process' );
    register_activation_hook( __FILE__, 'authority_robot_active_process' );

}

do_action('authority_robot_init');