jQuery(document).ready(function($) {

    var article_exist = false;
    var video_exist = false;
    var image_exist = false;
    $('#ara-search-button').click(function(e) {

        e.preventDefault();

        article_exist = false;
        video_exist = false;
        image_exist = false;

        var keyword = $('#ara-search-keyword').val();

        if(keyword == '') {
            return false;
        }

        $('#ara-metabox-article-field').mask('Waiting...');
        $('#ara-metabox-youtube-field').mask('Waiting...');
        $('#ara-metabox-flickr-field').mask('Waiting...');
        $('#ara-search-button').attr("disabled","disabled");
        //$('#ara-search-button').addClass("ar-loading");
        $('#article_page_num').val('1');
        $('#video_page_num').val('1');
        $('#flickr_page_num').val('1');

       var data = {
            action : 'ara_search_keyword',
            keyword: keyword
       };

        $.post( ajax_object.ajax_url, data, function(respond) {
           // var ret_obj = $.parseJSON( respond );
            if(respond != null ) {
                var ret_obj = $.parseJSON(respond);
                $('#ara-search-button').removeAttr("disabled");
                $('#ara-metabox-article-field').unmask();
                $('#ara-metabox-youtube-field').unmask();
                $('#ara-metabox-flickr-field').unmask();
                //$('#ara-search-button').removeClass("ar-loading");
                if(ret_obj != null) {
                    if(ret_obj.article_result != null) {
                        article_exist = true;

                        UpdateArticleContent(ret_obj.article_result);
                    }

                    if(ret_obj.video_result != null) {
                        video_exist = true;
                        UpdateYoutubeContent(ret_obj.video_result);
                    }

                    if(ret_obj.image_result != null) {
                        image_exist = true;
                        UpdateFlickrContent(ret_obj.image_result);
                    }
                }

            }



        });
    });
    /*function UpdateArticleContent(content) {
        var article_html;
        article_html = '<div>';
        article_html += '<a href="' + content.article_url + '" target="_blank"><h2>'+content.article_title+'</h2></a>';
        article_html += '<p>author : ' + content.article_author + '</p>';
        article_html += '<p>published : ' + content.article_date_published + '</p>';
        article_html += '<p>last updated : ' + content.article_last_updated + '</p>';
        article_html += '<p><span>category : ' + content.article_category + '</span></p><br/>';
        article_html += '<p>summary : ' + content.article_summary + '</p>';
        article_html += '<a href="'+ content.article_url +'" target="_blank">url : ' + content.article_url + '</a>';
        $('#ara-metabox-article-field .ara-metabox-content #wp-custom-content-editor-container #custom-content_ifr').contents().find('#tinymce').html(article_html);
    }*/
    function UpdateArticleContent(content) {
        var article_html;
        $('#article_page_num').val(content.article_page_num);

        //console.log($.base64.decode(content.article_author_name));
        article_html = '<div>';
        article_html += '<h2>'+content.article_title+'</h2>';
        article_html += 'By ' + $.base64.decode(content.article_author_name);
        article_html += '<div><p>' + $.base64.decode(content.article_content) + '</p></div>';
        article_html += $.base64.decode(content.article_author);
        article_html += '</div>';
            //var html = $(article_html).find('div#page-inner').html();
        //$('#ara-metabox-article-field .ara-metabox-content #wp-custom-content-editor-container #custom-content_ifr').contents().find('#tinymce').html(article_html);
        $('#ara-metabox-article-field .ara-metabox-content').html(article_html);
     }
    function UpdateYoutubeContent(content) {
        var video_html;
        video_html = '<div>';
        video_html += '<h2>'+content.youtube_title+'</h2>';
        video_html += '<p><span>View Count : ' + content.youtube_view_count+'</span></p>'
        video_html += '<iframe width="400" height="310" src="http://www.youtube.com/embed/'+ content.youtube_id + '" frameborder="0" allowfullscreen></iframe>';
        video_html += '<p>url : ' + content.youtube_url + '</p>';
        $('#ara-metabox-youtube-field .ara-metabox-content1').html(video_html);
        $('#ara-youtube-id').val(content.youtube_id);
    }

    function UpdateFlickrContent(content) {
        var flickr_html;

        flickr_html = '<img src="'+ content.flickr_img_src+'" />';
        $('#ara-metabox-flickr-field .ara-metabox-content1').html(flickr_html);
        $('#ara-image-width').val(content.width);
        $('#ara-image-height').val(content.height);
    }

    $('#ara-article-button').click(function(e) {
        e.preventDefault();

        article_exist = false;
        var page_num = parseInt($('#article_page_num').val()) + 1;
        var keyword = $('#ara-search-keyword').val();
        if(keyword == '') {
            return false;
        }

        $('#ara-article-button').attr("disabled","disabled");
        $('#ara-metabox-article-field').mask('Waiting...');
        $('#article_page_num').val(page_num);
        var data = {
            action : 'ara_get_article',
            keyword: keyword,
            page_num: page_num
        };

        $.post( ajax_object.ajax_url, data, function(respond) {
            $('#ara-article-button').removeAttr("disabled");
            $('#ara-metabox-article-field').unmask();
            var ret_obj = $.parseJSON( respond );
            if(ret_obj != null) {
                article_exist = true;
                UpdateArticleContent(ret_obj);
            }
        });
    });

    $('#ara-video-button').click(function(e) {
        e.preventDefault();
        var page_num = parseInt($('#video_page_num').val()) + 1;
        var keyword = $('#ara-search-keyword').val();
        video_exist = false;
        if(keyword == '') {
            return false;
        }
        $('#ara-video-button').attr("disabled","disabled");
        $('#ara-metabox-youtube-field').mask('Waiting...');
        $('#video_page_num').val(page_num);
        var data = {
            action : 'ara_get_video',
            keyword: keyword,
            page_num: page_num
        };

        $.post( ajax_object.ajax_url, data, function(respond) {
            $('#ara-video-button').removeAttr("disabled");
            $('#ara-metabox-youtube-field').unmask();
            var ret_obj = $.parseJSON( respond );
            if(ret_obj != null) {
                video_exist = true;
                UpdateYoutubeContent(ret_obj);
            }
        });
    });

    $('#ara-flickr-button').click(function(e) {
        e.preventDefault();


        var page_num = parseInt($('#flickr_page_num').val()) + 1;
        var keyword = $('#ara-search-keyword').val();
        image_exist = false;
        if(keyword == '') {
            return false;
        }
        $('#ara-metabox-flickr-field').mask('Waiting...');
        $('#ara-flickr-button').attr("disabled","disabled");
        $('#flickr_page_num').val(page_num);
        var data = {
            action : 'ara_get_image',
            keyword: keyword,
            page_num: page_num
        };

        $.post( ajax_object.ajax_url, data, function(respond) {
            $('#ara-flickr-button').removeAttr("disabled");
            $('#ara-metabox-flickr-field').unmask();
            var ret_obj = $.parseJSON( respond );
            if(ret_obj != null) {
                image_exist = true;
                UpdateFlickrContent(ret_obj);
            }
        });
    });

    $('#ara-metabox-checkbox #ara-checkbox-article').change(function() {

        var article_val = $('#ara-metabox-checkbox #ara-checkbox-article').attr('checked');
        if(article_val == 'checked') {

            $('#ara-metabox-article-field').show();
        } else {
            $('#ara-metabox-article-field').hide();
        }
    });

    $('#ara-metabox-checkbox #ara-checkbox-video').change(function() {
        var article_val = $('#ara-metabox-checkbox #ara-checkbox-video').attr('checked');
        if(article_val == 'checked') {
            $('#ara-metabox-youtube-field').show();
        } else {
            $('#ara-metabox-youtube-field').hide();
        }
    });

    $('#ara-metabox-checkbox #ara-checkbox-image').change(function() {
        var article_val = $('#ara-metabox-checkbox #ara-checkbox-image').attr('checked');
        if(article_val == 'checked') {
            $('#ara-metabox-flickr-field').show();
        } else {
            $('#ara-metabox-flickr-field').hide();
        }
    });

    // ---- shortcode ------------
    $('#ara-article-get-shortcode').click(function(e) {
        e.preventDefault();

        if(article_exist == false)
            return;
        $('#ara-article-get-shortcode').attr("disabled","disabled");

        //var html = $('#ara-metabox-article-field .ara-metabox-content #wp-custom-content-editor-container #custom-content_ifr').contents().find('#tinymce').html();
        var html = $('#ara-metabox-article-field .ara-metabox-content').html();
        var encoded = $.base64.encode(html);
        var data = {
            action: 'ara_get_shortcode_article',
            encode_html: encoded
        }

        $.post(ajax_object.ajax_url, data, function(respond) {
            $('#ara-article-get-shortcode').removeAttr("disabled");
            if(respond != null) {
                var shortcode = '[ar-ezinearticle id="' + respond + '" ]';
                $('#ara-metabox-shortcode-article').text(shortcode);
            }
        });
    });
    $('#ara-video-get-shortcode').click(function(e){
        e.preventDefault();

        if(video_exist == false)
            return false;

        var youtube_width = $('#ara-youtube-width').val();
        var youtube_height = $('#ara-youtube-height').val();
        var youtube_id = $('#ara-youtube-id').val();
        var shortcode = '[ar-youtube id="' + youtube_id + '" width="' + youtube_width + '" height="' + youtube_height + '" ]';
        $('#ara-metabox-shortcode-youtube').text(shortcode);
    });

    $('#ara-image-get-shortcode').click(function(e){
        e.preventDefault();
        if(image_exist == false) {
            return false;
        }
        var img_src = $('#ara-metabox-flickr-field .ara-metabox-content1 img').attr('src');
        var img_width = $('#ara-image-width').val();
        var img_height = $('#ara-image-height').val();
        var shortcode = '[ar-flickr-image src="' + $.base64.encode(img_src) + '" width="' + img_width + '" height="' + img_height + '" ]';
        $('#ara-metabox-shortcode-image').text(shortcode);
    }) ;
});